﻿
using BLL;
using CommonFun;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MyThreadDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        #region 创建多线程
        private void button1_Click(object sender, EventArgs e)
        {
            ThreadStart ts = new ThreadStart(ShowThreadStartMag);
            ts += ShowThreadStartMag1;
            Thread thr = new Thread(ts);
            thr.Start();

            ParameterizedThreadStart tsp = new ParameterizedThreadStart(ShowThreadStartMag1);
            Thread thrp = new Thread(tsp);
            //进行了一次拆装箱
            thrp.Start("123");
        }

        public void ShowThreadStartMag()
        {
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ThreadStart线程开始执行");
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadStartMag1业务处理中。。。");
            Thread.Sleep(5000);
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ThreadStart线程结束执行");
        }

        public void ShowThreadStartMag1()
        {
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ThreadStart线程开始执行");
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadStartMag1业务处理中。。。");
            Thread.Sleep(5000);
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ThreadStart线程结束执行");
        }

        public void ShowThreadStartMag1(object o)
        {
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadStartMag1线程开始执行");
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadStartMag1业务处理中，参数：{o.ToString()}。。。");
            Thread.Sleep(5000);
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadStartMag1线程结束执行");
        }

        #endregion

        #region 前后台线程
        private void button2_Click(object sender, EventArgs e)
        {

            ThreadStart ts = new ThreadStart(ShowThreadStartIsBack);

            //前台线程
            Thread td = new Thread(ts);
            td.Start();

            //后台线程
            Thread tdBack = new Thread(ts);
            tdBack.IsBackground = true;
            tdBack.Start();
        }

        public void ShowThreadStartIsBack()
        {
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadStartIsBack线程开始执行");
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadStartIsBack业务处理中。。。");
            Thread.Sleep(5000);
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadStartIsBack线程结束执行");
        }
        #endregion

        #region 线程优先级     
        private void button3_Click(object sender, EventArgs e)
        {
            //Process.GetCurrentProcess().PriorityClass = ProcessPriorityClass.High;

            ThreadStart ts = new ThreadStart(ShowThreadStartIsBack);

            Thread td1 = new Thread(ts);
            td1.Priority = ThreadPriority.Lowest;
            td1.Start();

            Thread td2 = new Thread(ts);
            td2.Priority = ThreadPriority.BelowNormal;
            td2.Start();

            Thread td3 = new Thread(ts);
            td3.Priority = ThreadPriority.Normal;
            td3.Start();

            Thread td4 = new Thread(ts);
            td4.Priority = ThreadPriority.AboveNormal;
            td4.Start();

            Thread td5 = new Thread(ts);
            td5.Priority = ThreadPriority.Highest;
            td5.Start();
        }

        public void ShowThreadStartPriority()
        {
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadStartPriority线程开始执行");
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadStartPriority业务处理中。。。");
            Thread.Sleep(5000);
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadStartPriority线程结束执行");
        }
        #endregion

        #region 线程池创建
        private void button4_Click(object sender, EventArgs e)
        {
            WaitCallback wcb = new WaitCallback(ThreadPoolWaitCallbackmath);
            ThreadPool.QueueUserWorkItem(wcb, "我是参数");
        }

        public void ThreadPoolWaitCallbackmath(object o)
        {
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ThreadPoolWaitCallbackmath线程开始执行");
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ThreadPoolWaitCallbackmath业务处理中,业务参数{o.ToString()}。。。");
            Thread.Sleep(5000);
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ThreadPoolWaitCallbackmath线程结束执行");
        }

        #endregion

        #region 线程状态


        private void button5_Click(object sender, EventArgs e)
        {
            ThreadStart ts = new ThreadStart(ShowThreadState);
            Thread thr = new Thread(ts);
            Console.WriteLine(thr.ThreadState);
            thr.Start();
            Console.WriteLine(thr.ThreadState);
        }
        public void ShowThreadState()
        {
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadState线程开始执行");
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadState业务处理中。。。");
            Thread.Sleep(5000);
            Console.WriteLine($"ThreadID{Thread.CurrentThread.ManagedThreadId}:ShowThreadState线程结束执行");
        }

        private void button6_Click(object sender, EventArgs e)
        {
            ThreadStart ts = new ThreadStart(ShowThreadState);
            Thread thr = new Thread(ts);
            Console.WriteLine(thr.ThreadState);
            thr.Start();
            Console.WriteLine(thr.ThreadState);
            thr.Suspend();//方法已经弃用
            Console.WriteLine(thr.ThreadState);
            thr.Resume();
            Console.WriteLine(thr.ThreadState);
        }

        private void button9_Click(object sender, EventArgs e)
        {
            ThreadStart ts = new ThreadStart(ShowThreadState);
            Thread thr = new Thread(ts);
            Console.WriteLine(thr.ThreadState);
            thr.Start();
            Console.WriteLine(thr.ThreadState);
        }

        private void button8_Click(object sender, EventArgs e)
        {
            ThreadStart ts = new ThreadStart(ShowThreadState);
            Thread thr = new Thread(ts);
            Console.WriteLine(thr.ThreadState);
            thr.Start();
            Console.WriteLine(thr.ThreadState);
            thr.Join();
            Console.WriteLine(thr.ThreadState);
            Console.WriteLine("主线程执行结束");

        }

        private void button7_Click(object sender, EventArgs e)
        {
            ThreadStart ts = new ThreadStart(ShowThreadState);
            Thread thr = new Thread(ts);
            Console.WriteLine(thr.ThreadState);
            thr.Start();
            Console.WriteLine(thr.ThreadState);
            thr.Abort();
            Console.WriteLine(thr.ThreadState);
            Console.WriteLine("主线程执行结束");

        }

        private void button19_Click(object sender, EventArgs e)
        {
            ThreadStart ts = new ThreadStart(ShowThreadState);
            Thread thr = new Thread(ts);
            Console.WriteLine(thr.ThreadState);
            thr.Start();
            Console.WriteLine(thr.ThreadState);
            Thread.Sleep(6000);
            Console.WriteLine(thr.ThreadState);
            Console.WriteLine("主线程执行结束");
        }

        #endregion

        #region 无返回值TASK
        private void button10_Click(object sender, EventArgs e)
        {
            Action<object> taskaction = (T) =>
            {
                Console.WriteLine(T.ToString());
            };
            Action taskactionnopara = () =>
            {
                Console.WriteLine($"线程{Thread.CurrentThread.ManagedThreadId}：执行task");
            };

            Task t = new Task(taskactionnopara);
            t.Start();

            Task tp = new Task(taskaction, "123");
            tp.Start();

            Task.Factory.StartNew(taskactionnopara);

            Task.Factory.StartNew(taskaction, "456");

            TaskFactory tf = new TaskFactory();
            tf.StartNew(taskactionnopara);

            TaskFactory tfp = new TaskFactory();
            tfp.StartNew(taskaction, "789");
        }
        #endregion

        #region TASK有返回值
        private void button11_Click(object sender, EventArgs e)
        {

            Task<string> t = new Task<string>(() => "123");
            Task<string> t1 = new Task<string>(delegate () { return "456"; });
            Func<string> fun2 = new Func<string>(() => "789");
            fun2 += TaskFunReturn;
            Task<string> t2 = new Task<string>(fun2);

            t.Start();
            t1.Start();
            t2.Start();
            //.result卡着该线程。直到执行完成出现结果
            Console.WriteLine(t.Result);
            Console.WriteLine(t1.Result);
            Console.WriteLine(t2.Result);
        }

        string TaskFunReturn()
        {
            return Thread.CurrentThread.ManagedThreadId.ToString();
        }

        #endregion

        #region Task等待
        private void button12_Click(object sender, EventArgs e)
        {
            ////------------------------Task回调-------------------------
            //Task<int> t = new Task<int>(() =>
            //{
            //    var temp = 0;
            //    for (int i = 0; i < 10; i++)
            //    {
            //        temp += i;
            //    }
            //    return temp;
            //});

            //t.ContinueWith<string>((f) =>
            //{
            //    Console.WriteLine(f.Result.ToString());
            //    return f.Result.ToString();
            //});
            //t.Start();



            ////------------------TaskFactory回调----------------------------
            //TaskFactory<int> tf = new TaskFactory<int>();
            //var tft = tf.StartNew(() =>
            // {
            //     var temp = 0;
            //     for (int i = 0; i < 10; i++)
            //     {
            //         temp += i;
            //     }
            //     return temp;
            // });
            //tft.ContinueWith<string>((f) =>
            //{
            //    Console.WriteLine(f.Result.ToString());
            //    return f.Result.ToString();
            //});


            ////-----------------------ContinueWhenAll--------------------------
            //var cts = new CancellationTokenSource();
            //TaskFactory<int> tf1 = new TaskFactory<int>(cts.Token, TaskCreationOptions.AttachedToParent, TaskContinuationOptions.ExecuteSynchronously, TaskScheduler.Default);

            //Task<int> t1 = tf1.StartNew(() => { Console.WriteLine(1); return 1; });
            //Task<int> t2 = tf1.StartNew(() => { Console.WriteLine(2); return 2; });
            //Task<int> t3 = tf1.StartNew(() => { Console.WriteLine(3); return 3; });
            //Task<int> t4 = tf1.StartNew(() => { Console.WriteLine(4); return 4; });
            //Task<int> t5 = tf1.StartNew(() => { Console.WriteLine(5); return 5; });


            ////意思就是说当这些所有的线程都执行完了，在执行后面的线程
            ////第一个参数就是要执行的线程数组
            ////第二个参数就是   继续执行的线程
            //var tcwa = tf1.ContinueWhenAll(new[] { t1, t2, t3, t4, t5 }, tlReturn =>
            // {
            //     int temp = 0;
            //     for (int i = 0; i < tlReturn.Length; i++)
            //     {
            //         temp += tlReturn[i].Result;
            //     }
            //     Console.WriteLine(temp);
            //     return temp;
            // });

            //var tft1 = tf1.StartNew(() =>
            //{
            //    var temp = 0;
            //    for (int i = 0; i < 10; i++)
            //    {
            //        temp += i;
            //    }
            //    Console.WriteLine(temp);
            //    return temp;
            //});


            //-------------------------FromAsync-----------------------------------
            TaskFactory<long> tfFA = new TaskFactory<long>();
            Func<long> faDel = (() =>
            {
                Console.WriteLine("臧锋");
                return 10;
            });
            tfFA.FromAsync(faDel.BeginInvoke(null, null), (tr) =>
            {
                Console.WriteLine(tr.IsCompleted);
                return 11;
            });
        }
        #endregion

        #region Task等待
        private void button13_Click(object sender, EventArgs e)
        {
            Action taskactionnopara = () =>
            {
                Console.WriteLine($"线程{Thread.CurrentThread.ManagedThreadId}：执行task");
                Thread.Sleep(5000);
            };
            Task t = new Task(taskactionnopara);
            t.Start();
            t.Wait();
            Console.WriteLine("主线程执行完成");

            //Task.WaitAll
            //Task.WaitAny
        }
        #endregion

        private void Form1_Load(object sender, EventArgs e)
        {

        }
        #region TASK取消
        CancellationTokenSource clt = new CancellationTokenSource();

        private void button14_Click(object sender, EventArgs e)
        {
            Action taskactionnopara = () =>
            {
                Console.WriteLine($"线程{Thread.CurrentThread.ManagedThreadId}：执行task");
                Thread.Sleep(5000);
                Console.WriteLine($"线程{Thread.CurrentThread.ManagedThreadId}：执行task后");
            };
            Task tf = new Task(taskactionnopara, clt.Token);
            tf.Start();
            Console.WriteLine("主线程执行完成");
        }
        private void button16_Click(object sender, EventArgs e)
        {
            clt.Cancel();
        }

        #endregion

        /// <summary>
        /// 注意 button15_Click需要设置为async  里面也要写await
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private async void button15_Click(object sender, EventArgs e)
        {
            LogFun.st.Start();
            LogFun lg = new LogFun();
            lg.ShowThread("Main前");
            BLL.UserBLL ul = new BLL.UserBLL();

            var user = ul.GetUserBll(111);
            await user;
            ////直接await task<T>,可以直接返回对应的类型T
            ////await task 也会等待task执行完成
            //var user =await ul.GetUserBll(111);
            Console.WriteLine(user.Result.ID);

            // var t = ul.AddUser(new Module.User() { ID = 10, UserName = "as" });
            //Console.WriteLine(t.Status);
            //t.Wait();


            //await ul.AddUser(new Module.User() { ID = 10, UserName = "as" });


            lg.ShowThread("Main后");
        }

        public async Task<string> GetUserName()
        {
            Console.WriteLine($"线程ID：{Thread.CurrentThread.ManagedThreadId}。GetUserName开始执行");
            var t= await GetUserNameDao();
            Console.WriteLine($"线程ID：{Thread.CurrentThread.ManagedThreadId}。GetUserName结束执行");
            return t;
        }

        public async Task<string> GetUserNameDao()
        {
            Console.WriteLine($"线程ID：{Thread.CurrentThread.ManagedThreadId}。GetUserNameDao开始执行");
            var t = await Task<string>.Factory.StartNew(() => {
                Console.WriteLine($"线程ID：{Thread.CurrentThread.ManagedThreadId}。GetUserNameDao执行zhong");
                return "WDQ";

            });
            Console.WriteLine($"线程ID：{Thread.CurrentThread.ManagedThreadId}。GetUserNameDao结束执行");
            return t;
        }

        private void button17_Click(object sender, EventArgs e)
        {
            Parallel.For(0, 100,(t,state) => {
                Console.WriteLine($"当前线程ID：{Thread.CurrentThread.ManagedThreadId}。当前序号：{t}");
                Thread.Sleep(20);
               
            });
        }

        private void button18_Click(object sender, EventArgs e)
        {

        }
    }
}
